/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.g2d.dnd;

import java.awt.geom.Rectangle2D;

import org.simantics.scenegraph.g2d.G2DParentNode;
import org.simantics.utils.datastructures.hints.HintContext;
import org.simantics.utils.datastructures.hints.IHintContext;

/**
 * @author Tuukka Lehtonen
 */
public class DragItem<T> implements IDragItem {

    private final T           object;
    private final HintContext ctx = new HintContext();

    public DragItem(T obj) {
        if (obj == null)
            throw new NullPointerException("null object");
        this.object = obj;
    }

    public T getObject() {
        return object;
    }

    @Override
    public Rectangle2D getBounds() {
        return new Rectangle2D.Double(0, 0, 1, 1);
    }

    @Override
    public void paint(G2DParentNode parent) {
    }

    @Override
    public IHintContext getHintContext() {
        return ctx;
    }

}