/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.g2d.element.handler;

import java.awt.geom.Point2D;

import org.simantics.g2d.element.IElement;
import org.simantics.g2d.element.ElementClass.Single;
import org.simantics.g2d.element.handler.impl.DefaultTransform;
import org.simantics.g2d.element.handler.impl.Rotateable;

/**
 * 
 * @See {@link DefaultTransform} default impl
 * @See {@link Rotateable} default impl
 * @author Toni Kalajainen
 */
@Single
public interface Rotate extends ElementHandler {
	
	/**
	 * Rotate the element
	 * @param e the element
	 * @param theta the angle to rotate around the origin measured in radians
	 * @param origin origin of rotation (in element coordinates)
	 */
	void rotate(IElement e, double theta, Point2D origin);	

	/**
	 * Get angle of an element
	 * @param e element
	 * @return angle element rotation measured in radians
	 */
	double getAngle(IElement e);
	
}
