/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.g2d.element.handler;

import org.simantics.g2d.element.IElement;
import org.simantics.g2d.element.handler.impl.AbstractTogglable;
import org.simantics.g2d.element.handler.impl.TogglableImpl;

/**
 * A toggle clickable Element
 * 
 * 
 * @See {@link TogglableImpl}
 * @See {@link AbstractTogglable}
 * @author Toni Kalajainen
 */
public interface Togglable extends Clickable {

    public static final TogglableImpl INSTANCE = TogglableImpl.INSTANCE;

    public boolean isChecked(IElement e);

}
