/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.g2d.element.handler.impl.proxy;

import org.simantics.g2d.canvas.ICanvasContext;
import org.simantics.g2d.element.IElement;
import org.simantics.g2d.element.handler.HandleMouseEvent;
import org.simantics.scenegraph.g2d.events.MouseEvent;

/**
 * @author Toni Kalajainen
 */
public class ProxyHandleMouseEvent implements HandleMouseEvent {

	private static final long serialVersionUID = -7537830259701341647L;
	HandleMouseEvent orig;
	IProxyProvider provider;
	
	public ProxyHandleMouseEvent(IProxyProvider provider, HandleMouseEvent orig) {
		this.provider = provider;
		this.orig = orig;
	}

	@Override
	public boolean handleMouseEvent(IElement e, ICanvasContext ctx, MouseEvent me) {		
		return orig.handleMouseEvent(provider.provide(e), ctx, me);
	}
	
	
}
