/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.g2d.element.handler.impl.proxy;

import java.awt.geom.Point2D;

import org.simantics.g2d.element.IElement;
import org.simantics.g2d.element.handler.Move;


/**
 * @author Toni Kalajainen
 */
public class ProxyMove implements Move {

    private static final long serialVersionUID = -60190372870461077L;

    Move orig;
    IProxyProvider provider;

    public ProxyMove(IProxyProvider provider, Move orig) {
        this.provider = provider;
        this.orig = orig;
    }

    @Override
    public Point2D getPosition(IElement e) {
        return orig.getPosition( provider.provide(e) );		
    }

    @Override
    public void moveTo(IElement e, double x, double y) {
        orig.moveTo(e, x, y);
    }

}
