/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.g2d.image.impl;

import org.simantics.g2d.image.Image;
import org.simantics.utils.datastructures.cache.IProvider;

public abstract class AbstractProviderProxy implements IProvider<Image> {
    protected IProvider<Image> source;
    AbstractProviderProxy(IProvider<Image> source) {
        this.source = source;
    }
    @Override
    public int hashCode() {
        return source.hashCode() + getClass().hashCode();
    }
    @Override
    public boolean equals(Object obj) {
        if (obj == null) return false;
        if (!obj.getClass().equals(getClass())) return false;
        return ((AbstractProviderProxy)obj).source.equals(source);
    }
}

