/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.g2d.image.impl;

import java.lang.ref.WeakReference;

import org.simantics.g2d.image.Image;
import org.simantics.utils.datastructures.cache.IProvider;
import org.simantics.utils.datastructures.cache.ProvisionException;

public class CacheProvider extends AbstractProviderProxy {

	WeakReference<Image> ref;

	public CacheProvider(IProvider<Image> source) {
		super(source);
	}

	@Override
	public synchronized Image get() throws ProvisionException {
		if (ref!=null) {
			Image x = ref.get();
			if (x==null) ref=null; else return x;
		}
		Image x = source.get();
		ref = new WeakReference<Image>(x);
		return x; 
	}

	
	
}

