/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.g2d.svg;

//import org.apache.batik.util.CSSConstants;

/**
 * @author Tuukka Lehtonen
 */
public class StyleDesc {
    
    StrokeDesc stroke;
    FillDesc fill;
    double objectOpacity;
    
    public StyleDesc(StrokeDesc stroke, FillDesc fill) {
        this(stroke, fill, 1.0);
    }
    
    public StyleDesc(StrokeDesc stroke, FillDesc fill, double objectOpacity) {
        if (objectOpacity < 0 || objectOpacity > 1)
            throw new IllegalArgumentException("invalid object opacity: " + objectOpacity);
        
        this.stroke = stroke;
        this.fill = fill;
        this.objectOpacity = objectOpacity;
    }
    
    public StrokeDesc getStroke() {
        return stroke;
    }

    public FillDesc getFill() {
        return fill;
    }
    
    public double getObjectOpacity() {
        return objectOpacity;
    }
    
//    public String toStyleString() {
//        String s = "";
//        if (objectOpacity >= 0.0 && objectOpacity < 1.0) {
//            s += CSSConstants.CSS_OPACITY_PROPERTY + ":" + objectOpacity + ";";
//        }
//        if (stroke != null)
//            s += stroke.toStyleString();
//        if (fill != null)
//            s += fill.toStyleString();
//        return s;
//    }

}
